﻿app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract; 
var myDocument = app.activeDocument;
var myDataMerge = myDocument.dataMergeProperties;
var myDataMergePrefs = myDataMerge.dataMergePreferences;
//myDataMergePrefs.recordsPerPage = RecordsPerPage.singleRecord;
myDataMergePrefs.recordsPerPage = RecordsPerPage.multipleRecord;
myDataMergePrefs.leftMargin = 1.2;
myDataMergePrefs.rightMargin = 0;
myDataMergePrefs.rowSpacing = 0.3;
myDataMergePrefs.topMargin = 1.27;
myDataMergePrefs.bottomMargin = 1.2;
myDataMerge.updateDataSource();
myDataMerge.mergeRecords();
pause(10000);
var myDocument2 = app.activeDocument;

var myPage = myDocument2.pages.add(LocationOptions.atBeginning);
myPage.appliedMaster = myDocument2.masterSpreads[1];
main();
function main(){
	var myObject;
	var myCheckSelection = false;
	if(app.documents.length > 0){
		if(app.selection.length > 0){
			switch(app.selection[0].constructor.name){
				case "InsertionPoint":
				case "Character":
				case "Word":
				case "TextStyleRange":
				case "Line":
				case "Paragraph":
				case "TextColumn":
				case "Text":
				
			
					
			
				default:
					myFindChangeByList(app.documents.item(0), false);
			}
		}
		else{
			//Nothing was selected, so simply search the document.
			myFindChangeByList(app.documents.item(0), false);
		}
	}
	else{
		alert("No documents are open. Please open a document and try again.");
	}
}

function myFindChangeByList(myObject, myCheckSelection){
	myObject = app.documents.item(0);
				myCheckSelection = false;
	var myScriptFileName, myFindChangeFile, myFindChangeFileName, myScriptFile, myResult;
	var myFindChangeArray, myFindPreferences, myChangePreferences, myFindLimit;
	var myStartCharacter, myEndCharacter;
	var myFindChangeFile = myFindFile("/../../FindChangeSupport/FindChangeList.txt")
	if(myFindChangeFile != null){
        // Because the selection will change as we add/remove characters,
        // we'll need to reset the selection after each pass if we are
        // checking the selection. We'll get the index of the first character
        // in the selection (relative to the start of its parent story) and
        // the index of the last character in the selection (relative to the
        // *end* of the story, and we'll use them later in the script to
        // keep the ends of the selection in place.
		if(myCheckSelection == true){
			var myStart = myObject.characters.item(0).index;
			var myEnd = myObject.characters.item(-1).index;
			var myStory = myObject.parentStory;
			var myStoryEnd = myStory.characters.item(-1).index;
			myEnd = (myStoryEnd - myEnd)+1;
		}
		myFindChangeFile = File(myFindChangeFile);
		var myResult = myFindChangeFile.open("r", undefined, undefined);
		if(myResult == true){
			//Loop through the find/change operations.
			do{
				myLine = myFindChangeFile.readln();
				//Ignore comment lines and blank lines.
				if((myLine.substring(0,4)!="text")||(myLine.substring(0,4)!="grep")||(myLine.substring(0,5)!="glyph")){
					myFindChangeArray = myLine.split("\t");
					//The first field in the line is the findType string.
					myFindType = myFindChangeArray[0];
					//The second field in the line is the FindPreferences string.
					myFindPreferences = myFindChangeArray[1];
					//The second field in the line is the ChangePreferences string.
					myChangePreferences = myFindChangeArray[2];
					//The fourth field is the range--used only by text find/change.
					myFindChangeOptions = myFindChangeArray[3];
					switch(myFindType){
						case "text":
							myFindText(myObject, myFindPreferences, myChangePreferences, myFindChangeOptions);
							break;
						case "grep":
							myFindGrep(myObject, myFindPreferences, myChangePreferences, myFindChangeOptions);
							break;
						case "glyph":
							myFindGlyph(myObject, myFindPreferences, myChangePreferences, myFindChangeOptions);
							break;
					}
					if(myCheckSelection == true){
						myStartCharacter = myStory.characters.item(myStart);
						myEndCharacter = myStory.characters.item(-myEnd);
						myObject = myStory.texts.itemByRange(myStartCharacter, myEndCharacter);
						app.select (myObject);
					}
				}
			} while(myFindChangeFile.eof == false);
			myFindChangeFile.close();
		}
	}
}
function myFindText(myObject, myFindPreferences, myChangePreferences, myFindChangeOptions){
	//Reset the find/change preferences before each search.
	app.changeTextPreferences = NothingEnum.nothing;
	app.findTextPreferences = NothingEnum.nothing;
	app.findChangeTextOptions = NothingEnum.nothing;
	var myString = "app.findTextPreferences.properties = "+ myFindPreferences + ";";
	myString += "app.changeTextPreferences.properties = " + myChangePreferences + ";";
	myString += "app.findChangeTextOptions.properties = " + myFindChangeOptions + ";";
	app.doScript(myString, ScriptLanguage.javascript);
		myFoundItems = myObject.changeText();
	//Reset the find/change preferences after each search.
	app.changeTextPreferences = NothingEnum.nothing;
	app.findTextPreferences = NothingEnum.nothing;
	app.findChangeTextOptions = NothingEnum.nothing;
}
function myFindGrep(myObject, myFindPreferences, myChangePreferences, myFindChangeOptions){
	//Reset the find/change grep preferences before each search.
	app.changeGrepPreferences = NothingEnum.nothing;
	app.findGrepPreferences = NothingEnum.nothing;
	app.findChangeGrepOptions = NothingEnum.nothing;
	var myString = "app.findGrepPreferences.properties = "+ myFindPreferences + ";";
	myString += "app.changeGrepPreferences.properties = " + myChangePreferences + ";";
	myString += "app.findChangeGrepOptions.properties = " + myFindChangeOptions + ";";
	app.doScript(myString, ScriptLanguage.javascript);
	var myFoundItems = myObject.changeGrep();
	//Reset the find/change grep preferences after each search.
	app.changeGrepPreferences = NothingEnum.nothing;
	app.findGrepPreferences = NothingEnum.nothing;
	app.findChangeGrepOptions = NothingEnum.nothing;
}
function myFindGlyph(myObject, myFindPreferences, myChangePreferences, myFindChangeOptions){
	//Reset the find/change glyph preferences before each search.
	app.changeGlyphPreferences = NothingEnum.nothing;
	app.findGlyphPreferences = NothingEnum.nothing;
	app.findChangeGlyphOptions = NothingEnum.nothing;
	var myString = "app.findGlyphPreferences.properties = "+ myFindPreferences + ";";
	myString += "app.changeGlyphPreferences.properties = " + myChangePreferences + ";";
	myString += "app.findChangeGlyphOptions.properties = " + myFindChangeOptions + ";";
	app.doScript(myString, ScriptLanguage.javascript);
	var myFoundItems = myObject.changeGlyph();
	//Reset the find/change glyph preferences after each search.
	app.changeGlyphPreferences = NothingEnum.nothing;
	app.findGlyphPreferences = NothingEnum.nothing;
	app.findChangeGlyphOptions = NothingEnum.nothing;
}
function myFindFile(myFilePath){
	var myScriptFile = myGetScriptPath();
	var myScriptFile = File(myScriptFile);
	var myScriptFolder = myScriptFile.path;
	myFilePath = myScriptFolder + myFilePath;
	if(File(myFilePath).exists == false){
		//Display a dialog.
		myFilePath = File.openDialog("Choose the file containing your find/change list");
	}
	return myFilePath;
}
function myGetScriptPath(){
	try{
		myFile = app.activeScript;
	}
	catch(myError){
		myFile = myError.fileName;
	}
	return myFile;
}




var actvScript = new File(app.activeScript);
var pathFile = new File(actvScript.path + "/../Path.txt");
pathFile.open();
var rootPath = pathFile.readln();
myDocument2.exportFile(ExportFormat.SWF, File(rootPath+"/A4-2.SWF"), false);

function pause(millis) {  
        var date = new Date();
        var curDate = null;

        do { curDate = new Date(); } 
        while(curDate-date < millis)
}



